#include "delay.h"

static	uint8_t  sysclk = 72;   /*ĬϵͳʱΪ72MHz*/
static  uint8_t  fac_us=0;      /*usʱ	*/
static  uint16_t fac_ms=0;      /*msʱ */

/**
	*ƣvoid Delay_Init(void)
	*
	*أ
	*ܣ׼ʱʼʹSysTick
	*עSysTickʱԴHCLK/8ṩϵͳƵΪ72MHzʱ
           СΪ1/9MHz,9Ϊ1usfac_us9Ϊλ  
**/

void Delay_Init(void)
{
	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);
	fac_us = sysclk/8;		    
	fac_ms=(u16)fac_us*1000;
}


/**
	*ƣvoid Delay_ms(u16 nms)
	*nms(ms number)  ܳ1864
	*أ
	*ܣ뼶ʱ
	*עSysTick->LOADΪ24λĴ,ʱСڻ1864ms
**/
void Delay_ms(u16 nms)
{	 		  	  
	u32 temp;		   
	SysTick->LOAD=(u32)nms*fac_ms;/*ʱ(SysTick->LOADΪ24bit)*/
	SysTick->VAL =0x00;           /*ռ */
	SysTick->CTRL=0x01 ;          /*ʼ  */  
	do
	{
		temp=SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16))); /*ȴʱ䵽   */
	SysTick->CTRL=0x00;       /*رռ	 */
	SysTick->VAL =0X00;       /*ռ	*/  	    
} 


/**
	*ƣvoid Delay_us(u32 nus)
	*us(number us) ʱ΢ 1864135
	*أ
	*: ʵ΢뼶ʱʱ1864ms
	*עͨĴõģûжӦĹ̼⺯οmisc.h
**/		    								   
void Delay_us(u32 nus)
{		
	u32 temp;	    	 
	SysTick->LOAD=nus*fac_us; /*ʱ fac_us=9,9ξ1us	*/  		 
	SysTick->VAL=0x00;        /*ռ */
	SysTick->CTRL=0x01 ;      /*ʼ */	 
	do
	{
		temp=SysTick->CTRL;
	}
	while(temp&0x01&&!(temp&(1<<16)));/*ȴʱ䵽*/   
	SysTick->CTRL=0x00;       /*رռ	*/
	SysTick->VAL =0X00;       /*ռ	*/
}

/*---LCDʱ 10MS*nCount-----*/
void Delay_10ms(uint32_t nCount)
{
	volatile int i;	 	
	for (i=0;i<nCount*100;i++);
}
