/**
	lcd.cԼ¼
	ˢ OK

**/
#include "lcd.h"
#include "font.h"
#include "stdio.h"
#include "delay.h"

/* Private variable ---------------------------------------------------------*/
uint16_t DeviceCode;


/* Private typedef -----------------------------------------------------------*/

/* private function */

void LCD_WR_REG(uint16_t LCD_Reg)
{
	LCD_RD(1);					/*ʧ*/
	LCD_CS(0);					/*Ƭѡ*/
	LCD_RS(0);					/*0ʾ*/
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Reg&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Reg&0xff00); 
	LCD_WR(0);				
	LCD_WR(1);					/*д*/
	LCD_CS(1);		  
}

void LCD_WR_DATA(uint16_t LCD_Data)	
{
	LCD_RD(1);					/*ʧ*/
	LCD_CS(0);
	LCD_RS(1);					/*1ʾ*/
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Data&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Data&0xff00);
	LCD_WR(0);
	LCD_WR(1);					/*д*/
	LCD_CS(1);	
} 


uint16_t LCD_ReadReg(uint16_t LCD_Reg)
{
//	uint16_t temp;
//	/* Ϊģʽ */
//	GPIOE->CRL=0x88888888;
//	GPIOE->CRH=0x88888888;
//
//	LCD_RD(1);					/*ʧ*/
//	LCD_CS(0);					/*Ƭѡ*/
//	LCD_RS(0);					/*0ʾ*/
//	DataToWrite(LCD_Reg);
//	LCD_WR(0);				
//	LCD_WR(1);					/*д*/
//
//	LCD_WR(1);					/*дʧ*/
//	LCD_RS(1);					/*1ʾ*/
//	temp=DataToRead();
//	LCD_RD(0);
//	LCD_RD(1);					/*ض*/
//	LCD_CS(1);
//
//	/* Ϊģʽ */
//	GPIOE->CRL=0x33333333;
//	GPIOE->CRH=0x33333333;
//	return temp;				    	 	
}

void LCD_WriteReg(uint16_t LCD_Reg ,uint16_t LCD_RegValue)
{
	LCD_WR_REG(LCD_Reg);
	LCD_WR_DATA(LCD_RegValue);			    
}

/**
	*ƣ
	*
	*أ
	*ܣ
	*עʼдGRAM
**/
void LCD_WR_DATA_Prepare(void)
{
	LCD_WR_REG(0x002C);
}


/**
	*ƣvoid LCD_SetCursor(u16 Xpos, u16 Ypos)
	*Xpos 
		   Ypos 
	*أ
	*ܣùλ
**/
void LCD_SetCursor(u16 Xpos, u16 Ypos)
{
	LCD_WR_REG(0x002A);	
	LCD_WR_DATA(Xpos>>8);	    
	LCD_WR_DATA(Xpos&0x00ff);
	LCD_WR_DATA(479>>8);	    
	LCD_WR_DATA(479&0x00ff);
    LCD_WR_REG(0x002b);	
	LCD_WR_DATA(Ypos>>8);	    
	LCD_WR_DATA(Ypos&0x00ff);
	LCD_WR_DATA(271>>8);	    
	LCD_WR_DATA(271&0x00ff);
}

/**
	*ƣvoid_LCD_Clear(uint16_t Colour)
	*Colour 16λɫ
	*أ
	*ܣָɫˢ
**/
void LCD_Clear(uint16_t Color)
{
    unsigned int l=480,w;

	/*--------ˢ--------*/
	/*  X  */
	LCD_WR_REG(0X002A);	
	LCD_WR_DATA(0);	    
	LCD_WR_DATA(0);
	LCD_WR_DATA(HDP>>8);	    
	LCD_WR_DATA(HDP&0XFF);

	/*  Y  */
    LCD_WR_REG(0X002B);	
	LCD_WR_DATA(0);	    
	LCD_WR_DATA(0);
	LCD_WR_DATA(VDP>>8);	    
	LCD_WR_DATA(VDP&0X00FF);

	LCD_WR_REG(0X002C);	
	while(l--)		  /* 480 */
	{
		for(w = 0; w < HDP+1; w++)  /* ÿ800ص */
		{ 	
			LCD_WR_DATA(Color);
		}
		
	}
}

/****************************************************************************
*     ƣu16 LCD_GetPoint(u16 x,u16 y)
*     ܣȡָɫֵ
* ڲx      
*           y      
* ڲǰɫֵ
* ˵    
* ÷CurrentColor = LCD_GetPoint(10,10);
* ע˺д֤˴
****************************************************************************/
//u16 LCD_GetPoint(u16 x,u16 y)
//{
//  LCD_SetCursor(x,y);
//  if(DeviceCode=0X8999)
//    return (LCD_ReadRAM());
//  else
//    return (LCD_BGRtoRGB(LCD_ReadRAM()));
//}

/**
	*ƣvoid LCD_DrawPoint(void)
	*xsta Xʼ 0~239
		   ysta	Yʼ 0~319
	*أ
	*ܣPOINT_COLORָɫ

**/
void LCD_DrawPoint(uint16_t xsta, uint16_t ysta, uint16_t color)
{
	LCD_SetCursor(xsta, ysta);  /*ùλ  */
	LCD_WR_DATA_Prepare();           /*ʼдGRAM */
	LCD_WR_DATA(color); 

}

/**					
	*ƣvoid LCD_WindowMax()
	*
	*أ
	*ܣô
	*ע
**/
void LCD_WindowMax (unsigned int xsta,unsigned int ysta,unsigned int xend,unsigned int yend) 
{
	LCD_WR_REG(0X002A);
	LCD_WR_DATA(xsta>>8);
	LCD_WR_DATA(xsta&0X00FF);
	LCD_WR_DATA(xend>>8);
	LCD_WR_DATA(xend&0X00FF);
		
	LCD_WR_REG(0X002B);	
	LCD_WR_DATA(ysta>>8);	
	LCD_WR_DATA(ysta&0X00FF);
	LCD_WR_DATA(yend>>8);	
	LCD_WR_DATA(yend&0X00FF);			
}

/**
	*ƣvoid LCD_Fill(uint8_t xsta, uint16_t ysta, uint8_t xend, uint16_t yend, uint16_t colour)
	*xsta ʼX
		   ysta ʼY
		   xend X
		   yend Y
		   color ɫ
	*أ
	*ܣָָɫС(xend-xsta)*(yend-ysta)
	*עһص	
**/
void LCD_Fill(uint8_t xsta, uint16_t ysta, uint8_t xend, uint16_t yend, uint16_t colour)
{                    
    u32 n;

	/*ô	*/	
	LCD_WindowMax (xsta, ysta, xend, yend); 
	LCD_WR_DATA_Prepare();         /*ʼдGRAM*/	 	   	   
	n=(u32)(yend-ysta+1)*(xend-xsta+1);    
	while(n--){LCD_WR_DATA(colour);} /*ʾɫ*/	 
}  

/**
	*ƣvoid LCD_DrawLine(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend)
	*xsta Xʼ
	   	   ysta Yʼ
		   xend Xյ
		   yend Yյ	
	*أ
	*ܣָ()
	*עҪɫ
**/ 
void LCD_DrawLine(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend, uint16_t color)
{
    u16 x, y, t;	 
	if((xsta==xend)&&(ysta==yend))
		LCD_DrawPoint(xsta, ysta, color);
	else 
		if(abs(yend-ysta)>abs(xend-xsta))/*бʴ1 */ 
		{
			if(ysta>yend) 
			{
				t=ysta;
				ysta=yend;
				yend=t; 
				t=xsta;
				xsta=xend;
				xend=t; 
			}
			for(y=ysta;y<yend;y++)            /*yΪ׼*/ 
			{
				x=(u32)(y-ysta)*(xend-xsta)/(yend-ysta)+xsta;
				LCD_DrawPoint(x, y, color);  
			}
		}
		else     /*бСڵ1 */
		{
			if(xsta>xend)
			{
				t=ysta;
				ysta=yend;
				yend=t;
				t=xsta;
				xsta=xend;
				xend=t;
			}   
			for(x=xsta;x<=xend;x++)  /*xΪ׼*/ 
			{
				y =(u32)(x-xsta)*(yend-ysta)/(xend-xsta)+ysta;
				LCD_DrawPoint(x, y, color); 
			}
		} 
} 

/**
	*ƣvoid Draw_Circle(uint16_t x0, uint16_t y0, uint8_t r)
	*x0 ĵ
	       y0 ĵ
		   r  뾶
	*أ
	*ܣָλûһָСԲ
	*עɫǷ
**/
void Draw_Circle(uint16_t x0, uint16_t y0, uint8_t r, uint16_t color)
{
	int a,b;
	int di;
	a=0;b=r;
		  
	di=3-(r<<1);             /*ж¸λõı־*/
	while(a<=b)
	{
		LCD_DrawPoint(x0-b, y0-a, color);             //3           
		LCD_DrawPoint(x0+b, y0-a, color);             //0           
		LCD_DrawPoint(x0-a, y0+b, color);             //1       
		LCD_DrawPoint(x0-b, y0-a, color);             //7           
		LCD_DrawPoint(x0-a, y0-b, color);             //2             
		LCD_DrawPoint(x0+b, y0+a, color);             //4               
		LCD_DrawPoint(x0+a, y0-b, color);             //5
		LCD_DrawPoint(x0+a, y0+b, color);             //6 
		LCD_DrawPoint(x0-b, y0+a, color); 
		a++;

		/*ʹBresenham㷨Բ*/     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x0+a, y0+b, color);
	}
} 

/**
	*ƣvoid LCD_DrawRectangle(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend)
	*xsta Xʼ
	       ysta Yʼ
		   xend X
		   yend Y
	*أ
	*ܣָ򻭾
	*ע

**/
void LCD_DrawRectangle(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend, uint16_t color)
{
	LCD_DrawLine(xsta, ysta, xend, ysta, color);
	LCD_DrawLine(xsta, ysta, xsta, yend, color);
	LCD_DrawLine(xsta, yend, xend, yend, color);
	LCD_DrawLine(xend, ysta, xend, yend, color);
} 

/**
	*ƣvoid LCD_ShowChar(u8 x, u16 y, u8 num, u8 size, u16 PenColor, u16 BackColor)
	*xy      ʼ꣨x:0~234 y:0~308
		   num       ַASCIIֵ
		   size      ַСʹĬ8*16
		   PenColor  ɫ
		   BackColor 屳ɫ
	*ܣ
	*עעĻС
**/
void LCD_ShowChar(u8 x, u16 y, u8 num, u8 size, u16 PenColor, u16 BackColor)
{       
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 304 
    u8 temp;
    u8 pos,t;
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY)return;		    
	num=num-' ';                         /*õƫƺֵ */
	for(pos=0;pos<size;pos++)
	{
		if(size==12)
			temp=asc2_1206[num][pos];/*1206*/
		else 
			temp=asc2_1608[num][pos];		 /*1608	*/
		for(t=0;t<size/2;t++)
	    {                 
	        if(temp&0x01)			   /*ӵλʼ*/
			{
				LCD_DrawPoint(x+t, y+pos, PenColor);  /*ɫ һ*/
			}
			else 
				LCD_DrawPoint(x+t, y+pos, BackColor);	   /*ɫ һ*/     
	        temp>>=1; 
	    }
	}			
} 

//m^n
u32 mypow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}			 
//ʾ2
//x,y :	 
//len :ֵλ
//size:С
//color:ɫ
//num:ֵ(0~4294967295);	 
void LCD_ShowNum(u8 x,u8 y,u32 num,u8 len, u16 PenColor, u16 BackColor)
{    
	u8 size = 16; /*  ʹĬϵ16*8  */     	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size, PenColor, BackColor);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size, PenColor, BackColor); 
	}
} 
  


/**
	ƣvoid LCD_ShowCharString(uint16_t x, uint16_t y, const uint8_t *p, uint16_t PenColor, uint16_t BackColor)
	xy      ʼ
	      p         ַָʼַ
		  PenColor  ַɫ
		  BackColor ɫ
	ܣ
	ע16壬Ե ˺ܵ
**/
void LCD_ShowCharString(uint16_t x, uint16_t y, const uint8_t *p, uint16_t PenColor, uint16_t BackColor)
{   
	uint8_t size = 16;     /*---ַСĬ16*8---*/
	 
    if(x>MAX_CHAR_POSX){x=0;y+=size;}			         /*XСλ*/
    if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(WHITE);}	 /*YСλصԭ㣬*/
    LCD_ShowChar(x, y, *p, size, PenColor, BackColor);			   /*0ʾǵӷʽ*/
}

/**
	*: u16 findHzIndex(u8 *hz)
	*hz
	*ܣִ洢ڴַ
	*ע
**/
u16 findHzIndex(u8 *hz)                            /* Զ庺ֿڲҪʾ */
                                                      /* ĺֵλ */
{
	u16 i=0;
	FNT_GB16 *ptGb16 = (FNT_GB16 *)GBHZ_16;		  /*ptGb16ָGBHZ_16*/
	while(ptGb16[i].Index[0] > 0x80)
	{
	    if ((*hz == ptGb16[i].Index[0]) && (*(hz+1) == ptGb16[i].Index[1])) /*λʾַ*/
		{
	        return i;
	    }
	    i++;
	    if(i > (sizeof((FNT_GB16 *)GBHZ_16) / sizeof(FNT_GB16) - 1))  /* ±Լ */
	    {
		    break;
	    }
	}
	return 0;
}

/**
	*ƣvoid WriteOneHz(uint16_t x0, uint16_t y0, uint8_t *pucMsk, uint16_t PenColor, uint16_t BackColor)
	*x0,y0     ʼ
		   *pucMsk   ָ
		   PenColor	 ַɫ
		   BackColor ɫ
	*ܣ
	*ע˺ܵΪַʾ											  
**/					
void WriteOneHz(u16 x0, u16 y0, u8 *pucMsk, u16 PenColor, u16 BackColor)
{
    u16 i,j;
    u16 mod[16];                                      /* ǰģ 16*16 */
    u16 *pusMsk;                                      /* ǰַֿ  */
    u16 y;

	u16 size = 16;       /*ĬϴС16*16*/

    pusMsk = (u16 *)pucMsk;


    for(i=0; i<16; i++)                                    /* 浱ǰֵʽģ       */
    {
        mod[i] = *pusMsk;                                /* ȡõǰģֶ   */
        mod[i] = ((mod[i] & 0xff00) >> 8) | ((mod[i] & 0x00ff) << 8);/* ģߵֽ*/
		pusMsk = pusMsk+1;
    }
    y = y0;
    for(i=0; i<16; i++)                                    /* 16   */
    {                                              
        for(j=0; j<16; j++)                                /* 16   */
        {
		    if((mod[i] << j) & 0x8000)       /* ʾi 16 */
            {
				LCD_DrawPoint(x0+j, y0+i, PenColor); 
            } 
			else 
			{
				LCD_DrawPoint(x0+j, y0+i, BackColor);
			}
        }
        y++;
    }
}

/**
	*ƣvoid LCD_ShowHzString(u16 x0, u16 y0, u8 *pcStr, u16 PenColor, u16 BackColor)
	*x0y0    ʼ
		   pcStr     ָ
		   PenColor  ɫ
		   BackColor 屳
	*ܣʾַ
	*עܵ	       
**/
void LCD_ShowHzString(u16 x0, u16 y0, u8 *pcStr, u16 PenColor, u16 BackColor)
{
#define MAX_HZ_POSX 224
#define MAX_HZ_POSY 304 
	u16 usIndex;
	u8 size = 16; 
	FNT_GB16 *ptGb16 = 0;    
    ptGb16 = (FNT_GB16 *)GBHZ_16; 

	if(x0>MAX_HZ_POSX){x0=0;y0+=size;}			         /*XСλ*/
    if(y0>MAX_HZ_POSY){y0=x0=0;LCD_Clear(WHITE);}	   /*YСλصԭ㣬*/

	usIndex = findHzIndex(pcStr);
	WriteOneHz(x0, y0, (u8 *)&(ptGb16[usIndex].Msk[0]),  PenColor, BackColor); /* ʾַ */
}

/**
	*ƣvoid LCD_ShowString(u16 x0, u16 y0, u8 *pcstr, u16 PenColor, u16 BackColor)
	*x0 y0     ʼ
		   pcstr     ַָ
		   PenColor  ɫ
		   BackColor 屳ɫ
	*ܣַͺʾʵַʾ
	*ע	
**/
void LCD_ShowString(u16 x0, u16 y0, u8 *pcStr, u16 PenColor, u16 BackColor)
{
	while(*pcStr!='\0')
	{
	 	if(*pcStr>0x80) /*ʾ*/
		{
			LCD_ShowHzString(x0, y0, pcStr, PenColor, BackColor);
			pcStr += 2;
			x0 += 16;	
		}
		else           /*ʾַ*/
		{
			LCD_ShowCharString(x0, y0, pcStr, PenColor, BackColor);	
			pcStr +=1;
			x0+= 8;
		}
	
	}	

}

/****************************************************************************
*     ƣu16 ili9320_BGRtoRGB(u16 Color)
*     ܣRRRRRGGGGGGBBBBB Ϊ BBBBBGGGGGGRRRRR ʽ
* ڲColor      BRG ɫֵ
* ڲRGB ɫֵ
* ˵    ڲ
* ÷
****************************************************************************/
u16 LCD_RGBtoBGR(u16 Color)
{						   
  u16  r, g, b, bgr;

  b = (Color>>0)  & 0x1f;	/* ȡB    */
  g = (Color>>5)  & 0x3f;	/* мλ */
  r = (Color>>11) & 0x1f;	/* ȡR    */
  
  bgr =  (b<<11) + (g<<5) + (r<<0);

  return( bgr );
}

/****************************************************************************
*     ƣvoid LCD_DrawPicture(u16 StartX,u16 StartY,u16 EndX,u16 EndY,u16 *pic)
*     ܣָ귶ΧʾһͼƬ
* ڲStartX     ʼ
*           StartY     ʼ
*           EndX       н
*           EndY       н
            pic        ͼƬͷָ
* ڲ
* ˵    ͼƬȡģʽΪˮƽɨ裬16λɫģʽ
* ÷LCD_DrawPicture(0,0,100,100,(u16*)demo);
****************************************************************************/
void LCD_DrawPicture(u16 StartX,u16 StartY,u16 Xend,u16 Yend,u8 *pic)
{
	static	u16 i=0,j=0;
	u16 *bitmap = (u16 *)pic;
	for(j=0; j<Yend-StartY; j++)
	{
		for(i=0; i<Xend-StartX; i++) 
		LCD_DrawPoint(StartX+i, StartY+j, *bitmap++); 	
	}
}

void LCD_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC,ENABLE);

	/* GPIOB *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 
								| GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	/* ÿGPIOC  *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 
								| GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7 
								| GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOC, &GPIO_InitStructure);
}

void LCD_Init(void)
{
	LCD_Configuration();

//	LCD_WriteReg(0x0000,0x0001);
//	Delay_10ms(5); // Delay_10ms 50 ms 
//	///////////////////////////////////
//	Delay_10ms(5); // delay 50 ms 
//	LCD_WR_REG(0x00E2);	//PLL multiplier, set PLL clock to 120M
//	LCD_WR_DATA(0x0023);	    //N=0x36 for 6.5M, 0x23 for 10M crystal
//	LCD_WR_DATA(0x0002);
//	LCD_WR_DATA(0x0004);
//	
//	LCD_WR_REG(0x00E0);  // PLL enable
//	LCD_WR_DATA(0x0001);
//	Delay_10ms(1);
//	LCD_WR_REG(0x00E0);
//	LCD_WR_DATA(0x0003);
//	Delay_10ms(5);
//	LCD_WR_REG(0x0001);  // software reset
//	Delay_10ms(5);
//	LCD_WR_REG(0x00E6);	//PLL setting for PCLK, depends on resolution
//	LCD_WR_DATA(0x0001);
//	LCD_WR_DATA(0x0033);
//	LCD_WR_DATA(0x0032);
//
//	LCD_WR_REG(0x0036);
//	LCD_WR_DATA(0x000a);
//
//	LCD_WR_REG(0x00B0);	//LCD SPECIFICATION
//	LCD_WR_DATA(0x0020);
//	LCD_WR_DATA(0x0000);
//	LCD_WR_DATA((HDP>>8)&0X00FF);  //Set HDP
//	LCD_WR_DATA(HDP&0X00FF);
//  LCD_WR_DATA((VDP>>8)&0X00FF);  //Set VDP
//	LCD_WR_DATA(VDP&0X00FF);
//  LCD_WR_DATA(0x0000);
//
//	LCD_WR_REG(0x00B4);	//HSYNC
//	LCD_WR_DATA((HT>>8)&0X00FF);  //Set HT
//	LCD_WR_DATA(HT&0X00FF);
//	LCD_WR_DATA((HPS>>8)&0X00FF);  //Set HPS
//	LCD_WR_DATA(HPS&0X00FF);
//	LCD_WR_DATA(HPW);			   //Set HPW
//	LCD_WR_DATA((LPS>>8)&0X00FF);  //Set HPS
//	LCD_WR_DATA(LPS&0X00FF);
//	LCD_WR_DATA(0x0000);
//
//	LCD_WR_REG(0x00B6);	//VSYNC
//	LCD_WR_DATA((VT>>8)&0X00FF);   //Set VT
//	LCD_WR_DATA(VT&0X00FF);
//	LCD_WR_DATA((VPS>>8)&0X00FF);  //Set VPS
//	LCD_WR_DATA(VPS&0X00FF);
//	LCD_WR_DATA(VPW);			   //Set VPW
//	LCD_WR_DATA((FPS>>8)&0X00FF);  //Set FPS
//	LCD_WR_DATA(FPS&0X00FF);
//
//	LCD_WR_REG(0x00F0); //pixel data interface
//	LCD_WR_DATA(0x0003); /*16λ565ʽ*/
//
//  LCD_WR_REG(0x0021);	//ͼɫתģʽ
//
//	LCD_WR_REG(0x00BC);//Ҫ
//	LCD_WR_DATA(0x0080);//Աȶ
//	LCD_WR_DATA(0x0080);//
//	LCD_WR_DATA(0x0080);//Ͷֵ  //
//	LCD_WR_DATA(0x0001);//
//	LCD_WR_REG(0x0029); //display on
//
//	LCD_Clear(BLACK);

	#define  LCD_WriteCom	LCD_WR_REG
	#define  LCD_WriteRAM	LCD_WR_DATA
	#define  TimeDelay(x)	Delay_10ms(x/2)
	/*ssd1963Ĵ*/
	LCD_WriteCom(0x00E2);	
	LCD_WriteRAM(0x0023);
	// Set PLL with OSC = 10MHz (hardware)
    // Multiplier N = 35, VCO (>250MHz)= OSC*(N+1), VCO = 360MHz	   
	LCD_WriteRAM(0x0001);
	// Divider M = 2, PLL = 360/(M+1) = 120MHz
	LCD_WriteRAM(0x0004);
	// Validate M and N values
	TimeDelay(40);
	LCD_WriteCom(0x00E0);  // PLL enable
	LCD_WriteRAM(0x0001);
	TimeDelay(40);
	LCD_WriteCom(0x00E0);
	LCD_WriteRAM(0x0003);
	TimeDelay(50);
	LCD_WriteCom(0x0001);  			// software reset
	TimeDelay(50);
	LCD_WriteCom(0x00E6);
	LCD_WriteRAM(0x0004);
	LCD_WriteRAM(0x0093);
	LCD_WriteRAM(0x00e0);

	LCD_WriteCom(0x00B0);			//LCD SPECIFICATION
	LCD_WriteRAM(0x0000);
	LCD_WriteRAM(0x0000);
	LCD_WriteRAM((HDP>>8)&0X00FF);  //Set HDP
	LCD_WriteRAM(HDP&0X00FF);
    LCD_WriteRAM((VDP>>8)&0X00FF);  //Set VDP
	LCD_WriteRAM(VDP&0X00FF);
    LCD_WriteRAM(0x0000);
	TimeDelay(50);

	LCD_WriteCom(0x00B4);			//HSYNC
	LCD_WriteRAM((HT>>8)&0X00FF);  //Set HT
	LCD_WriteRAM(HT&0X00FF);
	LCD_WriteRAM((HPS>>8)&0X00FF);  //Set HPS
	LCD_WriteRAM(HPS&0X00FF);
	LCD_WriteRAM(HPW);			   //Set HPW
	LCD_WriteRAM((LPS>>8)&0X00FF);  //Set HPS
	LCD_WriteRAM(LPS&0X00FF);
	LCD_WriteRAM(0x0000);
	TimeDelay(50);

	LCD_WriteCom(0x00B6);			//VSYNC
	LCD_WriteRAM((VT>>8)&0X00FF);   //Set VT
	LCD_WriteRAM(VT&0X00FF);
	LCD_WriteRAM((VPS>>8)&0X00FF);  //Set VPS
	LCD_WriteRAM(VPS&0X00FF);
	LCD_WriteRAM(VPW);			   //Set VPW
	LCD_WriteRAM((FPS>>8)&0X00FF);  //Set FPS
	LCD_WriteRAM(FPS&0X00FF);
	TimeDelay(50);

	LCD_WriteCom(0x00BA);
	LCD_WriteRAM(0x0005);//0x000F);    //GPIO[3:0] out 1
	TimeDelay(50);

	LCD_WriteCom(0x00B8);
	LCD_WriteRAM(0x0007);    //GPIO3=input, GPIO[2:0]=output
	LCD_WriteRAM(0x0001);    //GPIO0 normal
	TimeDelay(50);

	LCD_WriteCom(0x0036); //rotation
	LCD_WriteRAM(0x0008);
	TimeDelay(50);

	LCD_WriteCom(0x00F0); //pixel data interface
	LCD_WriteRAM(0x0003);
	TimeDelay(50);


	TimeDelay(50);
	LCD_WriteCom(0x0029); //display on
	TimeDelay(50);

	LCD_WriteCom(0x00BE); //set PWM for B/L
	LCD_WriteRAM(0x0006);
	LCD_WriteRAM(0x0080);
	TimeDelay(50);
	
	LCD_WriteRAM(0x0001);
	LCD_WriteRAM(0x00f0);
	LCD_WriteRAM(0x0000);
	LCD_WriteRAM(0x0000);
	TimeDelay(50);

	LCD_WriteCom(0x00d0);//ö̬ 
	LCD_WriteRAM(0x000d);
	TimeDelay(50);
	LCD_Clear(BLACK);
}


